/*
 * NRFWireless.h
 *
 *  Created on: May 1, 2016
 *      Author: Hudo
 */

#ifndef L4_IO_WIRELESS_NRFWIRELESS_H_
#define L4_IO_WIRELESS_NRFWIRELESS_H_

#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>

#include "FreeRTOS.h"
#include "queue.h"
#include "task.h"
#include "semphr.h"

#include "nrf24L01Plus.h"
#include "sys_config.h"   /* WIRELESS_CHANNEL_NUM */
#include "lpc_sys.h"
#include "eint.h"

#ifdef __cplusplus
extern "C" {
#endif

int nrf_driver_init(void);     ///< Initializes nordic wireless chip

int nrf_driver_send(void* p, int len);     ///< Sends the data over nordic
int nrf_driver_receive(void* p, int len);  ///< Gets the data from nordic, returns true if packet was fetched


int nrf_driver_app_recv(void *p, int len);
int nrf_driver_get_timer(void *p, int len);///< Get system timer value.
char wireless_get_queued_pkt(QueueHandle_t qhandle, char *pkt, const uint32_t timeout_ms);

void NRFwireless_service(void);

void SenderWireless_service(void * data, unsigned short length);
void ReceiverWireless_service(void * data, unsigned short length);

/** @} */
#ifdef __cplusplus
}
#endif
#endif /* L4_IO_WIRELESS_NRFWIRELESS_H_ */
